Index: main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_utils.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_utils.py	(revision 17430)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_utils.py	(revision 17431)
@@ -52,9 +52,9 @@
         self.app['configuration']['2004'].booking_fee = 150.0
         self.app['configuration']['2004'].maint_fee = 180.0
-        self.app['configuration']['2004'].clearance_fee_pg = 1234.0
-        self.app['configuration']['2004'].clearance_fee_fp = 3456.0
-        self.student['studycourse'].certificate.school_fee_1 = 6666.0
-        self.student['studycourse'].certificate.school_fee_2 = 7777.0
-        self.student['studycourse'].certificate.school_fee_3 = 8888.0
+        #self.app['configuration']['2004'].clearance_fee_pg = 1234.0
+        #self.app['configuration']['2004'].clearance_fee_fp = 3456.0
+        #self.student['studycourse'].certificate.school_fee_1 = 6666.0
+        #self.student['studycourse'].certificate.school_fee_2 = 7777.0
+        #self.student['studycourse'].certificate.school_fee_3 = 8888.0
         self.student['studycourse'].certificate.study_mode = 'special_pg_ft'
         self.student.nationality = u'NG'
@@ -74,5 +74,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 28888.0)
+        self.assertEqual(payment.amount_auth, 204000.0) # tuition plus penalty
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
@@ -84,5 +84,5 @@
         self.student.lga = 'edo_afuze'
         error, payment = utils.setPaymentDetails('schoolfee',self.student)
-        self.assertEqual(payment.amount_auth, 8987.0)
+        self.assertEqual(payment.amount_auth, 184099.0)
         IWorkflowState(self.student).setState('returning')
         error, payment = utils.setPaymentDetails('schoolfee',self.student)
@@ -94,30 +94,5 @@
         self.assertEqual(payment.p_level, 200)
         self.assertEqual(payment.p_session, 2005)
-        self.assertEqual(payment.amount_auth, 8976.0)
-        self.assertEqual(payment.p_item, u'CERT1')
-        self.assertEqual(error, None)
-
-        configuration = createObject('waeup.SessionConfiguration')
-        configuration.academic_session = 2016
-        self.app['configuration'].addSessionConfiguration(configuration)
-        configuration = createObject('waeup.SessionConfiguration')
-        configuration.academic_session = 2017
-        self.app['configuration'].addSessionConfiguration(configuration)
-        configuration = createObject('waeup.SessionConfiguration')
-        configuration.academic_session = 2018
-        self.app['configuration'].addSessionConfiguration(configuration)
-        self.student['studycourse'].current_session = 2017
-        self.student['studycourse'].entry_session = 2015
-        error, payment = utils.setPaymentDetails('schoolfee',self.student)
-        self.assertEqual(payment.p_level, 200)
-        self.assertEqual(payment.p_session, 2018)
-        self.assertEqual(payment.amount_auth, 7777.0)
-        self.assertEqual(payment.p_item, u'CERT1')
-        self.assertEqual(error, None)
-        self.student['studycourse'].entry_session = 2014
-        error, payment = utils.setPaymentDetails('schoolfee',self.student)
-        self.assertEqual(payment.p_level, 200)
-        self.assertEqual(payment.p_session, 2018)
-        self.assertEqual(payment.amount_auth, 8888.0)
+        self.assertEqual(payment.amount_auth, 184088.0)
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
@@ -133,27 +108,6 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 1234.0)
-        self.assertEqual(payment.p_item, u'CERT1')
-        self.assertEqual(error, None)
-
-        self.app['faculties']['fac1'].code = u'FP'
-        error, payment = utils.setPaymentDetails('clearance',self.student)
-        self.assertEqual(payment.p_level, 100)
-        self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 3456.0)
-        self.assertEqual(payment.p_item, u'CERT1')
-        self.assertEqual(error, None)
-
-        error, payment = utils.setPaymentDetails('restitution',self.student)
-        self.assertEqual(error, 'Restitution fee payment not required.')
-        self.student['studycourse'].certificate.study_mode = 'ug_ft'
-        configuration = createObject('waeup.SessionConfiguration')
-        self.app['configuration']['2016'].restitution_fee = 1111.0
-        self.student['studycourse'].current_session = 2016
-        error, payment = utils.setPaymentDetails('restitution',self.student)
-        self.assertEqual(payment.p_level, 100)
-        self.assertEqual(payment.p_session, 2016)
-        self.assertEqual(payment.amount_auth, 1111.0)
-        self.assertEqual(payment.p_item, u'')
+        self.assertEqual(payment.amount_auth, 14000.0)
+        self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
 
@@ -164,5 +118,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 8888.0)
+        self.assertEqual(payment.amount_auth, 184099.0)
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/utils.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/utils.py	(revision 17430)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/utils.py	(revision 17431)
@@ -17,4 +17,6 @@
 ##
 import grok
+import os
+import csv
 from time import time
 from zope.component import createObject, queryUtility
@@ -26,8 +28,16 @@
 from waeup.kofa.accesscodes import create_accesscode
 from waeup.kofa.students.utils import trans
-from waeup.aaue.interswitch.browser import gateway_net_amt, GATEWAY_AMT
 from waeup.aaue.interfaces import MessageFactory as _
 
 MINIMUM_UNITS_THRESHOLD = 15
+
+schoolfees_path = os.path.join(
+    os.path.dirname(__file__), 'schoolfees.csv')
+reader = csv.DictReader(open(schoolfees_path, 'rb'))
+SCHOOLFEES = {item['code']:(item['tuition'], item.values()) for item in reader}
+acceptancefees_path = os.path.join(
+    os.path.dirname(__file__), 'acceptancefees.csv')
+reader = csv.DictReader(open(acceptancefees_path, 'rb'))
+ACCEPTANCEFEES = {item['code']:(item['acceptance'], item.values()) for item in reader}
 
 class CustomStudentsUtils(NigeriaStudentsUtils):
@@ -312,10 +322,4 @@
             p_item = acco_details['bt']
             amount = academic_session.booking_fee
-        elif category == 'restitution':
-            if student.current_session != 2016 \
-                or student.current_mode not in ('ug_ft', 'dp_ft') \
-                or student.is_fresh:
-                return _(u'Restitution fee payment not required.'), None
-            amount = academic_session.restitution_fee
         elif category == 'hostel_maintenance':
             amount = 0.0
@@ -338,4 +342,9 @@
             if student.state not in (ADMITTED, CLEARANCE, REQUESTED, CLEARED):
                 return _(u'Acceptance Fee payments not allowed.'), None
+            try:
+                certificate = student['studycourse'].certificate
+                p_item = certificate.code
+            except (AttributeError, TypeError):
+                return _('Study course data are incomplete.'), None
             if student.current_mode in (
                 'ug_ft', 'ug_pt', 'de_ft', 'de_pt',
@@ -343,33 +352,19 @@
                 and category != 'clearance_incl':
                     return _("Additional fees must be included."), None
-            if student.current_mode == 'ijmbe':
-                amount = academic_session.clearance_fee_ijmbe
-            elif student.current_mode == 'bridge':
-                amount = academic_session.clearance_fee_bridge
-            elif student.current_mode == 'dp_ft':
-                amount = academic_session.clearance_fee_dp
-            elif student.faccode == 'FP':
-                amount = academic_session.clearance_fee_fp
-            elif student.current_mode in ('ug_pt', 'de_pt', 'ug_dsh', 'de_dsh'):
-                amount = academic_session.clearance_fee_ug_pt
-            elif student.current_mode == 'special_pg_pt':
-                amount = academic_session.clearance_fee_pg_pt
-            elif student.faccode == 'FCS':
-                # Students in clinical medical sciences pay the medical
-                # acceptance fee
-                amount = academic_session.clearance_fee_med
             elif student.current_mode == 'special_pg_ft':
                 if category != 'clearance':
                     return _("No additional fees required."), None
-                amount = academic_session.clearance_fee_pg
-            else:
-                amount = academic_session.clearance_fee
-            p_item = student['studycourse'].certificate.code
-            if amount in (0.0, None):
-                return _(u'Amount could not be determined.'), None
-            # Add Matric Gown Fee and Lapel Fee
+            try:
+                acceptancefees_entry = ACCEPTANCEFEES[student.certcode]
+            except KeyError:
+                return _('Acceptance fees not yet fixed.'), None
             if category == 'clearance_incl':
-                amount += gateway_net_amt(academic_session.matric_gown_fee) + \
-                    gateway_net_amt(academic_session.lapel_fee)
+                for item in acceptancefees_entry[1]:
+                    try:
+                        amount += int(item)
+                    except:
+                        pass
+            else:
+                amount = float(acceptancefees_entry[0])
         elif category == 'late_registration':
             if student.is_postgrad:
@@ -388,4 +383,8 @@
             except (AttributeError, TypeError):
                 return _('Study course data are incomplete.'), None
+            try:
+                schoolfees_entry = SCHOOLFEES[student.certcode]
+            except KeyError:
+                return _('School fees not yet fixed.'), None
             if student.is_postgrad and category != 'schoolfee':
                 return _("No additional fees required."), None
@@ -404,11 +403,12 @@
                     return _("You are not allowed "
                              "to pay by instalments."), None
-            # We determine the base amount first
-            if student.entry_session < 2015:
-                amount = getattr(certificate, 'school_fee_3', 0.0)
-            elif student.entry_session < 2021:
-                amount = getattr(certificate, 'school_fee_2', 0.0)
-            else:
-                amount = getattr(certificate, 'school_fee_1', 0.0)
+            additional = 0.0
+            for item in schoolfees_entry[1]:
+                try:
+                    additional += int(item)
+                except:
+                    pass
+            amount = float(schoolfees_entry[0])
+            additional -= amount
             if previous_session:
                 # Students can pay for previous sessions in all
@@ -419,5 +419,5 @@
                 # Cut school fee by 50%
                 if category in ('schoolfee_1', 'schoolfee_2') and amount:
-                    amount = gateway_net_amt(amount) / 2 + GATEWAY_AMT
+                    amount /= 2
             elif student.state == RETURNING and category != 'schoolfee_2':
                 if not student.father_name:
@@ -434,26 +434,14 @@
                 # Cut school fee by 50%
                 if category == 'schoolfee_1' and amount:
-                    amount = gateway_net_amt(amount) / 2 + GATEWAY_AMT
+                    amount /= 2
             elif category == 'schoolfee_2' and amount:
-                amount = gateway_net_amt(amount) / 2 + GATEWAY_AMT
+                amount /= 2
             else:
                 return _('Wrong state.'), None
             if amount in (0.0, None):
                 return _(u'Amount could not be determined.'), None
-            # Add Student Union Fee, Student Id Card Fee, Sports Dev. Fee,
-            # Library Dev. Fee and Welfare Assurance
-            if category in ('schoolfee_incl', 'schoolfee_1') \
-                and student.current_mode != 'ijmbe':
-                amount += gateway_net_amt(academic_session.welfare_fee) + \
-                    gateway_net_amt(academic_session.union_fee)
-                if student.entry_session >= 2018 and student.is_fresh:
-                    amount += gateway_net_amt(academic_session.sports_fee)
-                    if student.is_postgrad:
-                        amount += gateway_net_amt(academic_session.library_pg_fee)
-                    else:
-                        amount += gateway_net_amt(academic_session.library_fee)
-                if student.entry_session >= 2021 \
-                    and student.current_mode == 'ug_ft':
-                    amount += gateway_net_amt(academic_session.lms_sund_fee)
+            # Add additional fees
+            if category in ('schoolfee_incl', 'schoolfee_1'):
+                amount += additional
             # Add non-indigenous fee and session specific penalty fees
             if student.is_postgrad:
@@ -463,23 +451,4 @@
             else:
                 amount += academic_session.penalty_ug
-        #elif category == ('fac_dep'):
-        #    if student.faccode in ('FAT', 'FED', 'FLW', 'FMS', 'FSS'):
-        #        amount = 4200.0
-        #    elif student.faccode in ('FAG', 'FBM', 'FCS',
-        #                             'FES', 'FET', 'FLS', 'FPS'):
-        #        amount = 5200.0
-        #    elif student.faccode == 'FAG' and student.current_level == 400:
-        #        amount = 10200.0
-        #    elif student.depcode == 'VTE':
-        #        amount = 5200.0
-        #    if student.entry_session >= 2019:
-        #        amount += gateway_net_amt(academic_session.ict_fee)
-        elif category == 'sports_library': # temporarily in 2020
-            if student.is_postgrad:
-                amount = academic_session.sports_fee + gateway_net_amt(
-                    academic_session.library_pg_fee)
-            else:
-                amount = academic_session.sports_fee + gateway_net_amt(
-                    academic_session.library_fee)
         elif not student.is_postgrad:
             fee_name = category + '_fee'
Index: main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 17430)
+++ main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 17431)
@@ -93,42 +93,42 @@
         'clearance': 'Acceptance Fee without additional fees',
         'clearance_incl': 'Acceptance Fee incl. additional fees',
-        'hostel_maintenance': 'Hostel Accommodation Fee',
+        ##'hostel_maintenance': 'Hostel Accommodation Fee',
         #'application': 'Application Fee',
         #'bed_allocation': 'Bed Allocation Fee',
         #'transfer': 'Transfer Fee',
-        'transcript_local': 'Local Transcript Fee',
-        'transcript_inter': 'International Transcript Fee',
-        'late_registration': 'Late Course Registration Fee',
+        ##'transcript_local': 'Local Transcript Fee',
+        ##'transcript_inter': 'International Transcript Fee',
+        ##'late_registration': 'Late Course Registration Fee',
         #'welfare': 'Student Welfare Assurance Fee',
         #'union': 'Student Union Dues',
         #'lapel': 'Lapel/File Fee',
         #'matric_gown': 'Matriculation Gown Fee',
-        'concessional': 'Concessional Fee',
+        ##'concessional': 'Concessional Fee',
         #'id_card': 'Student ID Card',
-        'gst_text_book_0': 'Text Book Fee GST101 GST102 GST111 GST112',
-        'gst_text_book_1': 'Text Book Fee GST101 GST102',
-        'gst_text_book_2': 'Text Book Fee GST111 GST112',
-        'gst_text_book_3': 'Text Book Fee GST222',
-        'gst_registration_1': 'Registration Fee GST101 GST102 GST111 GST112',
-        'gst_registration_2': 'Registration Fee GST222',
-        'ent_text_book_1': 'Text Book Fee ENT201',
-        'ent_text_book_2': 'Text Book Fee ENT211',
-        'ent_text_book_0': 'Text Book Fee for ENT201 and ENT211',
-        'ent_registration_1': 'Registration Fee ENT201',
-        'ent_registration_2': 'Registration Fee ENT211',
-        'ent_registration_0': 'Registration Fee for ENT201 and ENT211',
-        'ent_combined': 'Registration and Textbook Fee for ENT201 and ENT211',
-        #'fac_dep': 'Faculty and Departmental Dues (incl. ICT/Affidavit Dues)',
-        'ict': 'ICT/Affidavit Dues',
-        #'affidavit': 'Affidavit Dues',
-        'restitution': 'Restitution Fee',
-        'sports': 'Sports Fee',
-        'library': 'UG Library Fee',
-        'library_pg': 'PG Library Fee',
-        'sports_library': 'Sports Development and Library Fee',
-        'lab_1': 'Faculty Laboratory Due (CHM102/PHY103/CSC101)',
-        'lab_2': 'Laboratory Due (BIO101/BIO111)',
-        'lms_sund': 'LMS plus Sundry Fees (new UG students only)',
-        'access_card': 'AAU Access Card Fee',
+        ##'gst_text_book_0': 'Text Book Fee GST101 GST102 GST111 GST112',
+        ##'gst_text_book_1': 'Text Book Fee GST101 GST102',
+        ##'gst_text_book_2': 'Text Book Fee GST111 GST112',
+        ##'gst_text_book_3': 'Text Book Fee GST222',
+        ##'gst_registration_1': 'Registration Fee GST101 GST102 GST111 GST112',
+        ##'gst_registration_2': 'Registration Fee GST222',
+        ##'ent_text_book_1': 'Text Book Fee ENT201',
+        ##'ent_text_book_2': 'Text Book Fee ENT211',
+        ##'ent_text_book_0': 'Text Book Fee for ENT201 and ENT211',
+        ##'ent_registration_1': 'Registration Fee ENT201',
+        ##'ent_registration_2': 'Registration Fee ENT211',
+        ##'ent_registration_0': 'Registration Fee for ENT201 and ENT211',
+        ##'ent_combined': 'Registration and Textbook Fee for ENT201 and ENT211',
+        ##'fac_dep': 'Faculty and Departmental Dues (incl. ICT/Affidavit Dues)',
+        ##'ict': 'ICT/Affidavit Dues',
+        ##'affidavit': 'Affidavit Dues',
+        ##'restitution': 'Restitution Fee',
+        ##'sports': 'Sports Fee',
+        ##'library': 'UG Library Fee',
+        ##'library_pg': 'PG Library Fee',
+        ##'sports_library': 'Sports Development and Library Fee',
+        ##'lab_1': 'Faculty Laboratory Due (CHM102/PHY103/CSC101)',
+        ##'lab_2': 'Laboratory Due (BIO101/BIO111)',
+        ##'lms_sund': 'LMS plus Sundry Fees (new UG students only)',
+        ##'access_card': 'AAU Access Card Fee',
         }
 
@@ -141,9 +141,9 @@
         'clearance': 'Acceptance Fee',
         'schoolfee': 'School Fee',
-        'late_registration': 'Late Course Registration Fee',
-        'sports': 'Sports Fee',
-        'library': 'UG Library Fee',
-        'library_pg': 'PG Library Fee',
-        'sports_library': 'Sports Development and Library Fee',
+        ##'late_registration': 'Late Course Registration Fee',
+        ##'sports': 'Sports Fee',
+        ##'library': 'UG Library Fee',
+        ##'library_pg': 'PG Library Fee',
+        ##'sports_library': 'Sports Development and Library Fee',
         }
 
@@ -153,9 +153,9 @@
         'schoolfee_1': 'School Fee (1st instalment)',
         'schoolfee_2': 'School Fee (2nd instalment)',
-        'sports': 'Sports Fee',
-        'library': 'UG Library Fee',
-        'library_pg': 'PG Library Fee',
-        'sports_library': 'Sports Development and Library Fee',
-        'exam': 'IJMBE Examination Fee',
+        ##'sports': 'Sports Fee',
+        ##'library': 'UG Library Fee',
+        ##'library_pg': 'PG Library Fee',
+        ##'sports_library': 'Sports Development and Library Fee',
+        ##'exam': 'IJMBE Examination Fee',
         }
 
@@ -163,24 +163,24 @@
         'clearance_incl': 'Acceptance Fee Plus',
         'schoolfee_incl': 'School Fee Plus',
-        'ent_text_book_1': 'Text Book Fee ENT201',
-        'ent_text_book_2': 'Text Book Fee ENT211',
-        'ent_text_book_0': 'Text Book Fee for ENT201 and ENT211',
-        'ent_registration_1': 'Registration Fee ENT201',
-        'ent_registration_2': 'Registration Fee ENT211',
-        'ent_registration_0': 'Registration Fee for ENT201 and ENT211',
-        'gst_registration_1': 'Registration Fee GST101 GST102 GST111 GST112',
-        'gst_registration_2': 'Registration Fee GST222',
-        'gst_text_book_0': 'Text Book Fee GST101 GST102 GST111 GST112',
-        'gst_text_book_1': 'Text Book Fee GST101 GST102',
-        'gst_text_book_2': 'Text Book Fee GST111 GST112',
-        'gst_text_book_3': 'Text Book Fee GST222',
-        'ent_combined': 'Registration and Textbook Fee for ENT201 and ENT211',
-        'late_registration': 'Late Course Registration Fee',
-        'sports': 'Sports Fee',
-        'library': 'UG Library Fee',
-        'library_pg': 'PG Library Fee',
-        'sports_library': 'Sports Development and Library Fee',
-        'lab_1': 'Faculty Laboratory Due (CHM102/PHY103/CSC101)',
-        'lab_2': 'Laboratory Due (BIO101/BIO111)',
+        ##'ent_text_book_1': 'Text Book Fee ENT201',
+        ##'ent_text_book_2': 'Text Book Fee ENT211',
+        ##'ent_text_book_0': 'Text Book Fee for ENT201 and ENT211',
+        ##'ent_registration_1': 'Registration Fee ENT201',
+        ##'ent_registration_2': 'Registration Fee ENT211',
+        ##'ent_registration_0': 'Registration Fee for ENT201 and ENT211',
+        ##'gst_registration_1': 'Registration Fee GST101 GST102 GST111 GST112',
+        ##'gst_registration_2': 'Registration Fee GST222',
+        ##'gst_text_book_0': 'Text Book Fee GST101 GST102 GST111 GST112',
+        ##'gst_text_book_1': 'Text Book Fee GST101 GST102',
+        ##'gst_text_book_2': 'Text Book Fee GST111 GST112',
+        ##'gst_text_book_3': 'Text Book Fee GST222',
+        ##'ent_combined': 'Registration and Textbook Fee for ENT201 and ENT211',
+        ##'late_registration': 'Late Course Registration Fee',
+        ##'sports': 'Sports Fee',
+        ##'library': 'UG Library Fee',
+        ##'library_pg': 'PG Library Fee',
+        ##'sports_library': 'Sports Development and Library Fee',
+        ##'lab_1': 'Faculty Laboratory Due (CHM102/PHY103/CSC101)',
+        ##'lab_2': 'Laboratory Due (BIO101/BIO111)',
         }
 
@@ -208,5 +208,7 @@
         }
 
-    BALANCE_PAYMENT_CATEGORIES = {
+    BALANCE_PAYMENT_CATEGORIES = {}
+
+    XXXBALANCE_PAYMENT_CATEGORIES = {
         'schoolfee': 'School Fee',
         'clearance': 'Acceptance Fee',
